#! /bin/sh
echo "MAJ de GolbalIP"

LOG_UPDATE="/usr/etc/update/files_after_update.txt"

if [ ! -e `dirname $LOG_UPDATE` ]
then
	mkdir `dirname $LOG_UPDATE`
fi
echo "Starting update at "`date` >> $LOG_UPDATE

#si on recupere le fichier a traiter en parametres
if [ 'ri'$1'en' = 'rien' ]
then
	TARGET_FILES_TGZ="/tmp/update/files.tgz"
else
	TARGET_FILES_TGZ=$1
fi
echo "The target file will be $TARGET_FILES_TGZ"

echo "Stopping services that do not interfere with the watchdog"
/etc/rc.d/init.d/displayappd stop
/etc/rc.d/init.d/webgip stop
/etc/rc.d/init.d/showgipd stop

echo "Checking if we are not downgrading"
if [ ! -e /usr/etc/GIP_VERSION ]
then
	echo "We could not find /usr/etc/GIP_VERSION seems like we are prototyping... ok to continue..."
else
	VERSION_TO_UPDATE_GET=$(cat /tmp/update/UPDATE_VERSION |grep version | cut -d':' -f2)
	VERSION_TO_UPDATE_UNIT=$(echo $VERSION_TO_UPDATE_GET |cut -d'.' -f3)
	VERSION_TO_UPDATE_MILLE=$(echo $VERSION_TO_UPDATE_GET |cut -d'.' -f2)
	VERSION_TO_UPDATE_MILLION=$(echo $VERSION_TO_UPDATE_GET |cut -d'.' -f1)
	VERSION_TO_UPDATE=$((($VERSION_TO_UPDATE_MILLION * 1000000) + ($VERSION_TO_UPDATE_MILLE * 1000) + ($VERSION_TO_UPDATE_UNIT )))
	
	VERSION_FROM_UPDATE_GET=$(cat /usr/etc/GIP_VERSION |grep version | cut -d':' -f2)
	VERSION_FROM_UPDATE_UNIT=$(echo $VERSION_FROM_UPDATE_GET |cut -d'.' -f3)
	VERSION_FROM_UPDATE_MILLE=$(echo $VERSION_FROM_UPDATE_GET |cut -d'.' -f2)
	VERSION_FROM_UPDATE_MILLION=$(echo $VERSION_FROM_UPDATE_GET |cut -d'.' -f1)
	VERSION_FROM_UPDATE=$((($VERSION_FROM_UPDATE_MILLION * 1000000) + ($VERSION_FROM_UPDATE_MILLE * 1000) + ($VERSION_FROM_UPDATE_UNIT )))
	
	if test $VERSION_FROM_UPDATE -gt $VERSION_TO_UPDATE 
	then
		echo "We cannot downgrade... we are going to stop the process"
		exit
	fi
fi

echo "Copying busybox and flashcp"
cd /tmp/update/
cp /usr/bin/flash* .
cp /bin/busybox .

echo "Updating files"
cd /
if [ -e /tmp/update/uboot.bin ]
then
	echo "flashing the uboot.bin" >> $LOG_UPDATE
	echo "flashing the uboot.bin"
	/tmp/update/flash_unlock /dev/mtd/0
	/tmp/update/flash_eraseall /dev/mtd/0
	/tmp/update/flashcp -v /tmp/update/uboot.bin /dev/mtd/0
fi
if [ -e /tmp/update/barebox.bin ]
then
	echo "flashing the barebox.bin" >> $LOG_UPDATE
	echo "flashing the barebox.bin"
	/tmp/update/flash_unlock /dev/mtd/0
	/tmp/update/flash_eraseall /dev/mtd/0
	/tmp/update/flashcp -v /tmp/update/barebox.bin /dev/mtd/0
fi

if [ -e /tmp/update/uImage ]
then
	echo "flashing the uimage" >> $LOG_UPDATE
	echo "flashing the uimage"
	/tmp/update/flash_unlock /dev/mtd/2
	/tmp/update/flash_eraseall /dev/mtd/2
	/tmp/update/flashcp -v /tmp/update/uImage /dev/mtd/2
fi

if [ -e /tmp/update/rootfs.jffs2 ]
then
	LOG_UPDATE="/tmp/files_after_update.txt"
	echo "changing LOG_UPDATE destination to "$LOG_UPDATE
	echo "flashing the rootfs.jffs2" >> $LOG_UPDATE
	echo "flashing the rootfs.jffs2"
	/tmp/update/flash_unlock /dev/mtd/4
	/tmp/update/flash_eraseall /dev/mtd/4
	/tmp/update/flashcp -v /tmp/update/rootfs.jffs2 /dev/mtd/4
else

	echo "Files updated" >> $LOG_UPDATE
	tar zxvf $TARGET_FILES_TGZ >> $LOG_UPDATE
	
	echo "Version updated : " >> $LOG_UPDATE
	cat /usr/etc/GIP_VERSION >> $LOG_UPDATE
	
	echo "chown root.root /etc/rc.d/init.d/*"
	chown root.root /etc/rc.d/init.d/* 
	echo "chmod 777 /etc/rc.d/init.d/*"
	chmod 777 /etc/rc.d/init.d/*
	echo "chmod 705 /root"
	chmod 705 /root
	
	
	#traitement pour ancienne version
	echo "Removing old files for maintain old version"
	if [ -e /tmp/files_to_remove ]
	then
		/bin/sh /tmp/files_to_remove
	fi
fi

echo "Executing things that need to be execute"
if [ -e /tmp/things_to_execute ]
then
	/bin/sh /tmp/things_to_execute
fi
 echo "Update finished at "`date` >> $LOG_UPDATE

/tmp/update/busybox reboot

